#include <vector>
#include <iostream>
#include <list>

using namespace std;

void print2dArr(vector<vector<int>>& arr) {
	for (const auto& x : arr) {
		for (const auto& y : x)
			cout << y << "\t";
		cout << "\n";
	}
}


void printArr(vector<int>& arr) {
	for (const auto& x : arr)
		cout << x << "\t";
	cout << endl;
}

void printPairArr(vector<pair<int, int>> arr) {
	for (const auto& x : arr) {
		cout << x.first << "\t" << x.second << endl;
	}
}

int main()
{

	int rows, cols;
	cin >> rows >> cols;
	vector<string> field;
	vector<pair<int, int>> holes;
	vector<pair<int, int>> flowers;
	
	for (int i = 0; i < rows; i++)
	{
		string temp;
		cin >> temp;
		for (int j = 0; j < cols; ++j) {
			if (temp[j] == 'H')
				holes.push_back(pair<int, int>(i, j));
			if (temp[j] == 'F')
				flowers.push_back(pair<int, int>(i, j));
		}
		field.push_back(temp);
	}
	
	pair<int, int> hole = holes[0];
	vector<pair<int, int>> places;
	if (field[hole.first + 1][hole.second] != 'F') {
		places.push_back(pair<int, int>(hole.first + 1, hole.second));
	}
	if (field[hole.first - 1][hole.second] != 'F') {
		places.push_back(pair<int, int>(hole.first - 1, hole.second));
	} if (field[hole.first][hole.second + 1] != 'F') {
		places.push_back(pair<int, int>(hole.first, hole.second + 1));
	} if (field[hole.first][hole.second - 1] != 'F') {
		places.push_back(pair<int, int>(hole.first, hole.second - 1));
	}
	cout << places.size() << endl;
	printPairArr(places);
}

