#include <iostream>
#include <vector>
#include <queue>

using namespace std;
typedef long long ll;

int n, m, q = 0;
vector<string> mp;
vector<vector<vector<int>>> dp;
vector<pair<int, int>> d = { {1, 0}, {0, -1}, {-1, 0}, {0, 1} };
void bfs(int x, int y) {
    queue<pair<int, int>> Q;
    Q.push({ x, y });
    dp[q][x][y] = 0;
    while (!Q.empty()) {
        auto tp = Q.front();
        Q.pop();

        for (auto w : d) {
            int nx = tp.first + w.first;
            int ny = tp.second + w.second;
            if (!(0 <= nx && nx < n && 0 <= ny && ny < m))
                continue;
            if (mp[nx][ny] != 'F' && dp[q][nx][ny] > n * m) {
                Q.push({ nx, ny });
                dp[q][nx][ny] = dp[q][tp.first][tp.second] + 1;
            }
        }
    }
    q++;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    mp.resize(n);
    for (int i = 0; i < n; i++)
        cin >> mp[i];
    dp.assign(100, vector<vector<int>>(n, vector<int>(m, n * m + 1)));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (mp[i][j] == 'H')
                bfs(i, j);
    vector<vector<int>> cost(n, vector<int>(m, -1));
    int ans = n * m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            for (int ii = 0; ii < q; ii++)
                cost[i][j] = max(cost[i][j], dp[ii][i][j]);
            ans = min(ans, cost[i][j]);
        }
    vector<pair<int, int>> res;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            if (cost[i][j] == ans)
                res.push_back({ i, j });
        }
    cout << res.size() << "\n";
    for (auto w : res)
        cout << w.first + 1 << " " << w.second + 1 << "\n";
    return 0;
}   