from math import sqrt

n, m = map(int, input().split(' '))
world = []
for _ in range(m-1): world += [list(input())]

def distance(p1, p2):
    x1, y1 = p1; x2, y2 = p2
    return abs(x1 - x2) + abs(y1 - y2)
    # How do we take into account flowers on our path?

def findPosOfType(type: str, world: list[list[str]]) -> list[tuple[int, int]]:
    acc = []
    for x in range(n):
        for y in range(m-1):
            if world[y][x] != type: continue
            acc.append((x, y))
    return acc

def heuristic(point: tuple[int, int], world: list[list[str]]) -> float:
    mole_distances = [distance(x, point) / distance(y, point) for x in findPosOfType('H', world) for y in findPosOfType['F', world]]
    return -sum(mole_distances)

def solve(world: list[list[str]]) -> list[tuple[int, int]]:
    empty_cells = findPosOfType('.', world)
    choices = sorted(empty_cells, key=lambda p: heuristic(p, world))
    return choices[:2]

if __name__ == "__main__":
    answer_set = solve(world)
    print(len(answer_set))

    for i in answer_set:
        print(" ".join( list((map(lambda x: str(x+1), i))) ))