#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll check(vector<vector<char>>& g, ll x, ll y) {
    if (g[x][y] == 'F') return -1;
    if (g[x][y] == 'H') return 1;
    return 0;
}

ll bfs(vector<vector<char>>& g, ll x, ll y) {
    vector<vector<ll>> d(g.size(), vector<ll>(g[0].size(), 0));
    queue<pair<ll, ll>> q;
    vector<vector<bool>> vis(g.size(), vector<bool>(g[0].size(), false));
    q.push({ x,y });
    d[x][y] = 0;
    ll ds = 0;
    while (!q.empty()) {
        pair<ll, ll> p = q.front();
        ll xl = p.first, yl = p.second;
        q.pop();
        vis[xl][yl] = true;
        ll c1 = check(g, xl - 1, yl);
        if (c1 != -1 && !vis[xl-1][yl]) {
            d[xl - 1][yl] = d[xl][yl] + 1;
            if (c1 == 1) {
                ds = max(ds, d[xl - 1][yl]);
            }
            q.push({ xl - 1,yl });
        }
        ll c2 = check(g, xl + 1, yl);
        if (c2 != -1 && !vis[xl + 1][yl]) {
            d[xl + 1][yl] = d[xl][yl] + 1;
            if (c2 == 1) {
                ds = max(ds, d[xl + 1][yl]);
            }
            q.push({ xl + 1,yl });
        }
        ll c3 = check(g, xl, yl - 1);
        if (c3 != -1 && !vis[xl][yl - 1]) {
            d[xl][yl - 1] = d[xl][yl] + 1;
            if (c3 == 1) {
                ds = max(ds, d[xl][yl - 1]);
            }
            q.push({ xl,yl - 1 });
        }
        ll c4 = check(g, xl, yl + 1);
        if (c4 != -1 && !vis[xl][yl + 1]) {
            d[xl][yl + 1] = d[xl][yl] + 1;
            if (c4 == 1) {
                ds = max(ds, d[xl][yl + 1]);
            }
            q.push({ xl,yl + 1 });
        }
    }
    return ds;
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<char>> g(n+2, vector<char>(m+2,'F'));
    vector<pair<ll, ll>> starts;
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= m; j++) {
            cin >> g[i][j];
            if (g[i][j] == '.') {
                starts.push_back({ i,j });
            }
        }
    }
    ll INF = 10e9;
    ll mind = INF;
    vector<vector<ll>> dist(n+2, vector<ll>(m+2, INF));
    for (auto& p : starts) {
        ll x = p.first, y = p.second;
        dist[x][y] = bfs(g,x,y);
        mind = min(mind, dist[x][y]);
    }
    vector<pair<ll, ll>> ans;
    for (auto& p : starts) {
        ll x = p.first, y = p.second;
        if (dist[x][y] == mind) ans.push_back(p);
    }
    cout << ans.size() << endl;
    for (auto& p : ans) {
        cout << p.first << " " << p.second << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
