#pragma GCC optimize("O3", "Ofast", "unroll-loops")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

bool check(vector<vector<char>>& g, ll x, ll y) {
    if (g[x][y] == 'F') return false;
    return true;
}

void bfs(vector<vector<char>>& g, vector<vector<ll>>& dist, ll x, ll y) {
    vector<vector<ll>> d(g.size(), vector<ll>(g[0].size(), 0));
    queue<pair<ll, ll>> q;
    vector<vector<bool>> vis(g.size(), vector<bool>(g[0].size(), false));
    q.push({ x,y });
    d[x][y] = 0;
    while (!q.empty()) {
        pair<ll, ll> p = q.front();
        ll xl = p.first, yl = p.second;
        q.pop();
        vis[xl][yl] = true;
        for (int i = -1; i <= 1; i++) {
            for (int j = -1; j <= 1; j++) {
                if (i != 0 && j != 0) continue;
                if (i == 0 && j == 0) continue;
                bool c = check(g, xl + i, yl + j);
                if (c && !vis[xl + i][yl + j]) {
                    d[xl + i][yl + j] = d[xl][yl] + 1;
                    dist[xl + i][yl + j] = max(d[xl + i][yl + j], dist[xl + i][yl + j]);
                    q.push({ xl + i,yl + j });
                }
            }
        }
    }
}

void solve() {
    ll n, m; cin >> n >> m;
    vector<vector<char>> g(n+2, vector<char>(m+2,'F'));
    vector<pair<ll, ll>> starts;
    vector<pair<ll, ll>> holes;
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= m; j++) {
            cin >> g[i][j];
            if (g[i][j] == 'H') {
                holes.push_back({ i,j });
            }
            if (g[i][j] != 'F') {
                starts.push_back({ i,j });
            }
        }
    }
    vector<vector<ll>> dist(n+2, vector<ll>(m+2, 0));
    for (auto& p : holes) {
        ll x = p.first, y = p.second;
        bfs(g,dist,x,y);
    }
    ll mind = 10e9;
    for (auto& p : starts) {
        ll x = p.first, y = p.second;
        mind = min(mind, dist[x][y]);
    }
    vector<pair<ll, ll>> ans;
    for (auto& p : starts) {
        ll x = p.first, y = p.second;
        if (dist[x][y] == mind) ans.push_back(p);
    }
    cout << ans.size() << endl;
    for (auto& p : ans) {
        cout << p.first << " " << p.second << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
