#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 2e5 + 10;

struct fenwick {
    int n;
    vector <long long> t;
    fenwick (int _n) {
        n = _n;
        t.assign (n, 0LL);
    }
    void update (int i, long long delta) {
        i = n - 1 - i;
        for (; i < n; i |= (i + 1)) t[i] = max (t[i], delta);
    }
    long long get (int d) {
        d = n - 1 - d;
        long long result = 0;
        for (; d >= 0; d = ((d & (d + 1)) - 1)) result = max (result, t[d]);
        return result;
    }
} fw (maxn);

int a [maxn], pref [maxn];
long long S [maxn];
int d [maxn][19], st [25];
int tl [maxn], tr [maxn], LG [maxn];
long long result [maxn];
vector <int> graph [maxn];
vector <pair <int, int>> add [maxn];

inline long long sm (int L, int R) {
    long long RES = S[R];
    if (L > 0) RES -= S[L - 1];
    return RES;
}

signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    st[0] = 1;
    for (int i = 1; i < 25; ++i) st[i] = st[i - 1] * 2;
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) cin >> a[i];
    pref[0] = S[0] = a[0];
    for (int i = 1; i < n; ++i) pref[i] = __gcd (pref[i - 1], a[i]), S[i] = S[i - 1] + a[i];
    for (int i = 0; i < n; ++i) d[i][0] = a[i];
    for (int j = 1; j < 19; ++j)
        for (int i = 0; i < n; ++i) {
            if (i + st[j - 1] < n) d[i][j] = __gcd (d[i][j - 1], d[i + st[j - 1]][j - 1]);
            else d[i][j] = d[i][j - 1];
        }
    for (int i = 0; i < q; ++i) {
        cin >> tl[i] >> tr[i], --tl[i], --tr[i];
        graph[tr[i]].push_back (i);
    }
    for (int i = 0; i < n; ++i) if (!graph[i].empty ()) {
        vector <pair <int, int>> T = {{0, pref[i]}};
        while (T.back ().second != a[i]) {
            int pos = i, G = a[i];
            //cout << "HELLO " << pos + 1 << ' ' << G << '\n';
            for (int j = 18; j >= 0; --j) if (pos - st[j] >= 0) {
                if (__gcd (d[pos - st[j]][j], G) > T.back ().second) G = __gcd (d[pos - st[j]][j], G), pos -= st[j];
            }
            T.push_back (make_pair (pos, G));
        }
        //cout << "!! " << i + 1 << '\n';
        reverse (T.begin (), T.end ());
        //for (auto j : T) cout << "?? position: " << j.first + 1 << ' ' << ", gcd = " << j.second << '\n';
        for (int j : graph[i]) {
            int L = tl[j];
            for (auto V : T) {
                if (V.first < L) break;
                //cout << "@*#@(#(*#@ " << V.second << ' ' << sm (V.first, i) << '\n';
                result[j] = max (result[j], V.second * sm (V.first, i));
            }
        }
    }
    //cout << "!! " << result[0] << '\n';
    int P = 0;
    for (int i = n - 1; i >= 0; --i) {
        P = __gcd (P, a[i]);
        int pos = n - 1;
        add[n - 1].push_back (make_pair (i, P * sm (i, pos)));
        int Q = P;
        while (Q != a[i]) {
            pos = i;
            int G = a[i];
            for (int j = 18; j >= 0; --j) if (__gcd (G, d[pos + 1][j]) > Q) G = __gcd (G, d[pos + 1][j]), pos += st[j];
            add[pos].push_back (make_pair (i, 1LL * G * sm (i, pos)));
            Q = G;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : add[i]) fw.update (j.first, j.second);
        for (int j : graph[i]) {
            result[j] = max (result[j], fw.get (tl[j]));
        }
    }
    LG[1] = 0;
    for (int i = 2; i <= n; ++i) LG[i] = LG[i / 2] + 1;
    for (int i = 0; i < q; ++i) {
        int len = LG[tr[i] - tl[i] + 1];
        long long W = __gcd (d[tl[i]][len], d[tr[i] - len + 1][len]);
        W *= S[tr[i]] - (tl[i] == 0 ? 0LL : S[tl[i] - 1]);
        result[i] = max (result[i], W);
        cout << result[i] << ' ';
        cout << '\n';
    }
    return 0;
}