#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000LL;
constexpr ll sq = 450;

ll n, m, q, k, x, y, a, b, c;
vector<ll> v;
vector<ll> pr;
vector< vector<ll> > divs;

ll inter(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first > b.first) {
        swap(a, b);
    }
    if (b.first > a.second) {
        return 0;
    }
    return pr[min(b.second, a.second) + 1] - pr[max(a.first, b.first)];
}

struct segtree {
    vector<ll> tr;

    void build(ll x, ll l, ll r, vector<ll> &v) {
        if (l == r) {
            tr[x] = v[l];
            return;
        }
        ll mid = (r + l) / 2;
        build(x * 2 + 1, l, mid, v);
        build(x * 2 + 2, mid + 1, r, v);
        tr[x] = max(tr[x * 2 + 1], tr[x * 2 + 2]);
    }

    segtree() {

    }

    segtree(vector<ll> &v) {
        tr.resize(4 * v.size());
        build(0, 0, v.size() - 1, v);
    }

    ll get(ll x, ll l, ll r, ll L, ll R) {
        if (l > r) {
            return -INF;
        }
        if (L > r) {
            return -INF;
        }
        if (l > R) {
            return -INF;
        }
        if (L <= l && r <= R) {
            return tr[x];
        }
        ll mid = (l + r) / 2;
        return max(get(x * 2 + 1, l, mid, L, R), get(x * 2 + 2, mid + 1, r, L, R));
    }
};

unordered_map< ll, vector< pair<ll, ll> > > vr;
unordered_map<ll, segtree> sg;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin >> n >> q;
    v.resize(n);
    divs.resize(n);
    set<ll> st;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        vector<ll> divs1;
        // cout << "DEBUG" << endl;
        for (int j = 1; j * j <= v[i]; j++) {
            if (j * j == v[i]) {
                divs[i].push_back(j);
                if (i != 0 && v[i - 1] % j == 0) {
                    vr[j][vr[j].size() - 1].second++;
                }
                else {
                    vr[j].push_back({i, i});
                }
                st.insert(j);
            }
            else if (v[i] % j == 0) {
                divs[i].push_back(j);
                if (i != 0 && v[i - 1] % j == 0) {
                    vr[j][vr[j].size() - 1].second++;
                }
                else {
                    vr[j].push_back({i, i});
                }
                st.insert(j);
                divs1.push_back(v[i] / j);
                if (i != 0 && v[i - 1] % (v[i] / j) == 0) {
                    vr[v[i] / j][vr[v[i] / j].size() - 1].second++;
                }
                else {
                    vr[v[i] / j].push_back({i, i});
                }
                st.insert(v[i] / j);
            }
        }
        while (!divs1.empty()) {
            divs[i].push_back(divs1[divs1.size() - 1]);
            divs1.pop_back();
        }
    }
    pr.resize(n + 1);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + v[i];
    }
    vector<ll> ans(q);
    vector< pair<ll, ll> > vp;
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        x--;
        y--;
        vp.push_back({x, y});
    }
    while (st.size() > 0) {
        ll x = *st.rbegin();
        st.erase(x);
        // cout << x << endl;
        ll mx = 0;
        vector<ll> v2;
        for (auto i : vr[x]) {
            v2.push_back(pr[i.second + 1] - pr[i.first]);
            mx = max(mx, pr[i.second + 1] - pr[i.first]);
        }
        sg[x] = segtree(v2);
        for (int i = 0; i < q; i++) {
            if (mx * x < ans[i]) {
                continue;
            }
            // cout << '\t' << i << endl;
            ll l, r;
            ll idx = lower_bound(vr[x].begin(), vr[x].end(), make_pair(vp[i].first, -INF)) - vr[x].begin();
            // cout << "\t\t" << idx << endl;
            if (idx != vr[x].size()) {
                l = idx;
            }
            else {
                if (idx > 0) {
                    // cout << "\t\t\ta" << vp[i].first << ' ' << vr[x][idx - 1].second << endl;
                    ans[i] = max(ans[i], x * inter(vp[i], vr[x][idx - 1]));
                }
                continue;
            }
            idx = upper_bound(vr[x].begin(), vr[x].end(), make_pair(vp[i].second, INF)) - vr[x].begin();
            // cout << "\t\t" << idx << endl;
            if (idx != 0) {
                r = idx - 1;
            }
            else {
                continue;
            }
            if (l > 0) {
                ans[i] = max(ans[i], x * inter(vp[i], vr[x][l - 1]));
            }
            ans[i] = max(ans[i], x * inter(vp[i], vr[x][r]));
            r--;
            // cout << "\t\t\tb" << l << ' ' << r << '\n';
            ans[i] = max(ans[i], sg[x].get(0, 0, v2.size() - 1, l, r) * x);
        }
    }
    for (int j = 0; j < q; j++) {
        cout << ans[j] << '\n';
    }
}
