from collections import deque

def bfs(sx, sy, n, m, garden):

    visited = [[False] * m for _ in range(n)]
    distance = [[float('inf')] * m for _ in range(n)]
    distance[sx][sy] = 0
    queue = deque([(sx, sy)])
    while queue:
        x, y = queue.popleft()
        for dx, dy in [(1, 0), (-1, 0), (0, 1), (0, -1)]:
            nx, ny = x + dx, y + dy
            if 0 <= nx < n and 0 <= ny < m and not visited[nx][ny] and garden[nx][ny] != 'F':
                visited[nx][ny] = True
                distance[nx][ny] = distance[x][y] + 1
                queue.append((nx, ny))
    return distance

n, m = map(int, input().split())
garden = [input() for _ in range(n)]

holes = []
for i in range(n):
    for j in range(m):
        if garden[i][j] == 'H':
            holes.append((i, j))
holes_distances = []
for hole in holes:
    distances = bfs(hole[0], hole[1], n, m, garden)
    holes_distances.append(distances)

min_max_distance = float('inf')
for i in range(n):
    for j in range(m):
        if garden[i][j] == '.':
            max_distance = max(holes_distances[k][i][j] for k in range(len(holes)))
            if max_distance < min_max_distance:
                min_max_distance = max_distance

optimal_positions = []
for i in range(n):
    for j in range(m):
        if garden[i][j] == '.':
            max_distance = max(holes_distances[k][i][j] for k in range(len(holes)))
            if max_distance == min_max_distance:
                optimal_positions.append((i + 1, j + 1))

print(len(optimal_positions))
for position in optimal_positions:
    print(position[0], position[1])