#include <algorithm>
#include <climits>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define nl "\n"

struct triair {
  ll first;
  ll second;
  ll third;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, x, y, p, o, q;
  string str;
  bool bl;
  char ch;
  cin >> n >> m;
  char arr[n][m];
  vector<pair<ll, ll>> holes;
  ll empty_cells[n][m];
  vector<pair<ll, ll>> empty_cells_list;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> arr[i][j];
      if (arr[i][j] == 'H') {
        holes.push_back({i, j});
      }
      if (arr[i][j] != 'F') {
        empty_cells[i][j] = 0;
        empty_cells_list.push_back({i, j});
      }
    }
  }
  queue<triair> bfs;
  bool visited[n][m];
  for (auto hole : holes) {
    bfs = queue<triair>();
    bfs.push(triair{hole.first, hole.second, 0});
    for (ll i = 0; i < n; i++) {
      for (ll j = 0; j < m; j++) {
        visited[i][j] = false;
      }
    }
    while (!bfs.empty()) {
      triair current_cell = bfs.front();
      bfs.pop();
      if (visited[current_cell.first][current_cell.second]) {
        continue;
      }

      visited[current_cell.first][current_cell.second] = true;
      empty_cells[current_cell.first][current_cell.second] =
          max(empty_cells[current_cell.first][current_cell.second],
              current_cell.third);
      if (current_cell.first > 0 &&
          arr[current_cell.first - 1][current_cell.second] != 'F') {
        bfs.push({current_cell.first - 1, current_cell.second,
                  current_cell.third + 1});
      }
      if (current_cell.first < n - 1 &&
          arr[current_cell.first + 1][current_cell.second] != 'F') {
        bfs.push({current_cell.first + 1, current_cell.second,
                  current_cell.third + 1});
      }
      if (current_cell.second > 0 &&
          arr[current_cell.first][current_cell.second - 1] != 'F') {
        bfs.push({current_cell.first, current_cell.second - 1,
                  current_cell.third + 1});
      }
      if (current_cell.second < m - 1 &&
          arr[current_cell.first][current_cell.second + 1] != 'F') {
        bfs.push({current_cell.first, current_cell.second + 1,
                  current_cell.third + 1});
      }
    }
  }
  ll mindist = LLONG_MAX;
  vector<pair<ll, ll>> winners;
  for (auto field : empty_cells_list) {
    if (empty_cells[field.first][field.second] < mindist) {
      mindist = empty_cells[field.first][field.second];
      winners.clear();
      winners.push_back(field);
    } else if (empty_cells[field.first][field.second] == mindist) {
      winners.push_back(field);
    }
  }
  cout << winners.size() << " " << nl;
  for (auto winner : winners) {
    cout << winner.first + 1 << " " << winner.second + 1 << nl;
  }
}
